using System;
using System.IO;
using System.Xml;
using System.Xml.Serialization;

namespace SMPPClient
{
	/// <summary>
	/// Summary description for Configuration.
	/// </summary>
	[Serializable]
	public class Configuration
	{
        private uint sourceTon;
        private uint sourceNpi;
        private string sourceAddress;
        private uint destinationTon;
        private uint destinationNpi;
        private string destinationAddress;
        private string host;
        private uint port;
        private string systemId;
        private string password;
        private string bindType;
        private string replaceIfPresent;
        private string registerDelivery;
        private string serviceType;
        private uint esm;
        private uint dcs;
        private uint priority;
        private uint enquireLinkInterval;

        public uint SourceTon
        {
            get{return this.sourceTon;}
            set{this.sourceTon = value;}
        }
        public uint SourceNpi
        {
            get { return this.sourceNpi; }
            set { this.sourceNpi = value; }
        }
        public string SourceAddress
        {
            get { return this.sourceAddress; }
            set { this.sourceAddress = value; }
        }
        public uint DestinationTon
        {
            get { return this.destinationTon; }
            set { this.destinationTon = value; }
        }
        public uint DestinationNpi
        {
            get { return this.destinationNpi; }
            set { this.destinationNpi = value; }
        }
        public string DestinationAddress
        {
            get { return this.destinationAddress; }
            set { this.destinationAddress = value; }
        }
        public string Host
        {
            get { return this.host; }
            set { this.host = value; }
        }
        public uint Port
        {
            get { return this.port; }
            set { this.port = value; }
        }
        public string SystemId
        {
            get { return this.systemId; }
            set { this.systemId = value; }
        }
        public string Password
        {
            get { return this.password; }
            set { this.password = value; }
        }
        public string BindType
        {
            get { return this.bindType; }
            set { this.bindType = value; }
        }
        public string ReplaceIfPresent
        {
            get { return this.replaceIfPresent; }
            set { this.replaceIfPresent = value; }
        }
        public string RegisterDelivery
        {
            get { return this.registerDelivery; }
            set { this.registerDelivery = value; }
        }
        public string ServiceType
        {
            get { return this.serviceType; }
            set { this.serviceType = value; }
        }
        public uint ESM
        {
            get { return this.esm; }
            set { this.esm = value; }
        }
        public uint DCS
        {
            get { return this.dcs; }
            set { this.dcs = value; }
        }
        public uint Priority
        {
            get { return this.priority; }
            set { this.priority = value; }
        }
        public uint EnquireLinkInterval
        {
            get { return this.enquireLinkInterval; }
            set { this.enquireLinkInterval = value; }
        }
		public Configuration()
		{
            this.SourceTon = 0;
            this.SourceNpi = 1;
            this.SourceAddress = "90799";
            this.DestinationTon = 1;
            this.DestinationNpi = 1;
            this.DestinationAddress = "359878500566";
            this.Host = "10.96.211.50";
            this.Port = 3701;
            this.SystemId = "SMPP1";
            this.Password = "smsc";
            this.BindType = "Transciever";
            this.ReplaceIfPresent = "false";
            this.RegisterDelivery = "true";
            this.ServiceType = "";
            this.ESM = 0;
            this.DCS = 0;
            this.Priority = 0;
            this.enquireLinkInterval = 10;
		}

		public static void Serialize(string file, Configuration c)
		{
			System.Xml.Serialization.XmlSerializer xs 
				= new System.Xml.Serialization.XmlSerializer(c.GetType());
			StreamWriter writer = File.CreateText(file);
			xs.Serialize(writer, c);
			writer.Flush();
			writer.Close();
		}

		public static Configuration Deserialize(string file)
		{
			System.Xml.Serialization.XmlSerializer xs 
				= new System.Xml.Serialization.XmlSerializer(
				typeof(Configuration));
			StreamReader reader = File.OpenText(file);
			Configuration c = (Configuration)xs.Deserialize(reader);
			reader.Close();
			return c;
		}
	}
}
