using System;
using System.Collections.Generic;
using System.Text;
using SMPP.Packet;

namespace SMPP.Packet.Request
{
    public abstract class MessageLcd6:Pdu
    {
        #region fields
        
        private TonType sourceAddressTon = Pdu.TonType.International;
        private NpiType sourceAddressNpi = Pdu.NpiType.ISDN;
        private string sourceAddress = string.Empty;

        #endregion fileds

        #region constants

        protected const int ADDRESS_LENGTH = 20;
        protected const int MSG_LENGTH = 64;
        protected const int SERVICE_TYPE_LENGTH = 50;

        #endregion constatnts

        #region properties 

        public TonType SourceAddressTon
        {
            get
            {
                return this.sourceAddressTon;
            }
            set
            {
                this.sourceAddressTon = value;
            }
        }

        public NpiType SourceAddressNpi
        {
            get
            {
                return this.sourceAddressNpi;
            }
            set
            {
                this.sourceAddressNpi = value;
            }
        }

        public string SourceAddress
        {
            get
            {
                return this.sourceAddress;
            }
            set
            {
                if (value != null)
                {
                    if (value.Length <= ADDRESS_LENGTH)
                    {
                        this.sourceAddress = value;
                    }
                    else
                    {
                        throw new ArgumentOutOfRangeException("Source Address must be <= " + ADDRESS_LENGTH + "cahracters");
                    }
                }
                else
                {
                    this.sourceAddress = string.Empty;
                }
            }
        }
        #endregion properties

        #region constructors
        protected MessageLcd6(): base()
        { }
        protected MessageLcd6(byte[] incomingBytes): base(incomingBytes)
        { }
        #endregion constructors

    }
}
