using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using SMPP.Packet;
using SMPP.Utility;

namespace SMPP.Packet.Request
{
    public class SmppOutbind:Pdu
    {
        #region fields
        private string systemId = string.Empty;
        private string password = string.Empty;
        #endregion

        #region properties
        public string SystemId
        {
            get { return this.systemId; }
            set { this.systemId = value; }
        }
        public string Password
        {
            get { return this.password; }
            set { this.password = value; }
        }
        #endregion

        #region constructors
        public SmppOutbind(): base()
        { }
        public SmppOutbind(byte[] incomingBytes): base(incomingBytes)
        { }
        #endregion

        protected override void DecodeSmscResponse()
        {
            byte[] remainder = BytesAfterHeader;
            SystemId = SmppStringUtil.GetCStringFromBody(ref remainder);
            Password = SmppStringUtil.GetCStringFromBody(ref remainder);
            TranslateTlvDataIntoTable(remainder);
        }

        protected override void InitPdu()
        {
            base.InitPdu();
            CommandStatus = 0;
            CommandID = CommandIdType.outbind;
        }

        public override void ToMsbHexEncoding()
        {
            ArrayList pdu = GetPduHeader();
            pdu.AddRange(SmppStringUtil.ArrayCopyWithNull(Encoding.ASCII.GetBytes(SystemId)));
            pdu.AddRange(SmppStringUtil.ArrayCopyWithNull(Encoding.ASCII.GetBytes(Password)));
            PacketBytes = EncodePduForTrasmission(pdu);
        }
    }
}
