using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using SMPP;
using SMPP.Utility;

namespace SMPP.Packet.Request
{
    public class SmppQuerySm :MessageLcd6
    {
        #region fields
        private string messageId = string.Empty;
        
        #endregion

        #region properties
        public string MessageId
        {
            get { return this.messageId; }
            set
            {
                if (value != null)
                {
                    if (value.Length < MSG_LENGTH)
                    {
                        this.messageId = value;
                    }
                    else
                    {
                        throw new ArgumentOutOfRangeException("Message ID must be <=" + MSG_LENGTH + "characters.");
                    }
                }
                else
                {
                    this.messageId = string.Empty;
                }
            }
        }

        #endregion

        #region constructors
        public SmppQuerySm(): base()
        { }
        public SmppQuerySm(byte[] incomingBytes): base(incomingBytes)
        { }
        #endregion

        protected override void InitPdu()
        {
            base.InitPdu();
            CommandStatus = 0;
            CommandID = CommandIdType.query_sm;
        }

        public override void ToMsbHexEncoding()
        {
            ArrayList pdu = GetPduHeader();
            pdu.AddRange(SmppStringUtil.ArrayCopyWithNull(Encoding.ASCII.GetBytes(MessageId)));
            pdu.Add((byte)SourceAddressTon);
            pdu.Add((byte)SourceAddressNpi);
            pdu.AddRange(SmppStringUtil.ArrayCopyWithNull(Encoding.ASCII.GetBytes(SourceAddress)));
            PacketBytes = EncodePduForTrasmission(pdu);
       }

        protected override void DecodeSmscResponse()
        {
            byte[] remainder = BytesAfterHeader;
            MessageId = SmppStringUtil.GetCStringFromBody(ref remainder);
            SourceAddressTon = (TonType)remainder[0];
            SourceAddressNpi = (NpiType)remainder[1];
            SourceAddress = SmppStringUtil.GetCStringFromBody(ref remainder,2);

            TranslateTlvDataIntoTable(remainder);
        }

    }
}
