using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using SMPP;
using SMPP.Utility;

namespace SMPP.Packet.Response
{
    public class SmppBindResp:Pdu
    {
        #region fields
        private string systemId = string.Empty;
        #endregion
        
        #region properties
        public string SystemId
        {
            get { return this.systemId; }
            set { this.systemId = value; }
        }
        #endregion

        #region optional parameters
        public string ScInterfaceVersion
        {
            get
            {
                return GetOptionalParamString((ushort)Pdu.OptionalParamCodes.SC_interface_version);
            }
            set
            {
                string version = value;
                if (value == null)
                {
                    version = string.Empty;
                }
                SetOptionalParamString((ushort)Pdu.OptionalParamCodes.SC_interface_version, version);
            }
        }
        #endregion

        #region constructors
        public SmppBindResp()
            : base()
        { }
        public SmppBindResp(byte[] incomingBytes)
            : base(incomingBytes)
        { }
        #endregion

        protected override void DecodeSmscResponse()
        {
            byte[] remainder = BytesAfterHeader;
            SystemId = SmppStringUtil.GetCStringFromBody(ref remainder);
            TranslateTlvDataIntoTable(remainder);
        }

        protected override void InitPdu()
        {
            base.InitPdu();
            CommandStatus = 0;
            CommandID = CommandIdType.bind_transceiver_resp;
        }

        public override void ToMsbHexEncoding()
        {
            ArrayList pdu = GetPduHeader();
            pdu.AddRange(SmppStringUtil.ArrayCopyWithNull(Encoding.ASCII.GetBytes(SystemId)));

            PacketBytes = EncodePduForTrasmission(pdu);
        }
            

                


    }
}
