using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using SMPP.Utility;

namespace SMPP.Packet.Response
{
    public class SmppQuerySmResp:Pdu
    {
        private string messageId = string.Empty;
        private string finalDate = string.Empty;
        private MessageStateType messageStatus = MessageStateType.Enroute;
        private byte errorCode = 0;

        public string MessageId
        {
            get
            {
                return this.messageId;
            }
            set
            {
                this.messageId = (value == null) ? string.Empty : value;
            }
        }
        public string FinalDate
        {
            get
            {
                return this.finalDate;
            }
            set
            {
                if(value != null && value !=string.Empty)
                {
                    if(value.Length == DATE_TIME_LENGTH)
                    {
                        this.finalDate = value;
                    }
                    else
                    {
                        throw new ArgumentException("Final date is not in th correct format.");
                    }
                }
                else
                {
                    this.finalDate = string.Empty;
                }
            }
        }

        public MessageStateType MessageStatus
        {
            get
            {
                return this.messageStatus;
            }
            set
            {
                this.messageStatus = value;
            }
        }

        public byte ErrorCode
        {
            get
            {
                return this.errorCode;
            }
            set
            {
                this.errorCode = value;
            }
        }

        public SmppQuerySmResp()
            : base()
        { }
        public SmppQuerySmResp(byte[] incomigBytes)
            : base(incomigBytes)
        { }

        protected override void DecodeSmscResponse()
        {
            byte[] remainder = BytesAfterHeader;
            MessageId = SmppStringUtil.GetCStringFromBody(ref remainder);
            FinalDate = SmppStringUtil.GetCStringFromBody(ref remainder);
            MessageStatus = (MessageStateType)remainder[0];
            ErrorCode = remainder[1];

            TranslateTlvDataIntoTable(remainder, 2);

        }

        protected override void InitPdu()
        {
            base.InitPdu();
            CommandStatus = 0;
            CommandID = CommandIdType.query_sm_resp;
        }

        public override void ToMsbHexEncoding()
        {
            ArrayList pdu = GetPduHeader();
            pdu.AddRange(SmppStringUtil.ArrayCopyWithNull(Encoding.ASCII.GetBytes(MessageId)));
            pdu.AddRange(SmppStringUtil.ArrayCopyWithNull(Encoding.ASCII.GetBytes(FinalDate)));
            pdu.Add((byte)MessageStatus);
            pdu.Add(ErrorCode);

            PacketBytes = EncodePduForTrasmission(pdu);
        }


    }
}
