using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using SMPP.Utility;

namespace SMPP.Packet.Response
{
    public class SmppSubmitSmResp : Pdu
    {
        private string messageId;
        private byte[] responseAfterMsgId;

        public string MessageId
        {
            get
            {
                return this.messageId;
            }
            set
            {
                this.messageId = (value == null) ? string.Empty : value;
            }
        }

        public byte[] ResponseAfterMsgId
        {
            get
            {
                return this.responseAfterMsgId;
            }
        }

        public SmppSubmitSmResp()
            : base()
        { }
        public SmppSubmitSmResp(byte[] incomigBytes)
            : base(incomigBytes)
        { }

        protected override void DecodeSmscResponse()
        {
            DecodeNonTlv();
            TranslateTlvDataIntoTable(this.responseAfterMsgId);
        }

        protected void DecodeNonTlv()
        {
            byte[] remainder = BytesAfterHeader;
            MessageId = SmppStringUtil.GetCStringFromBody(ref remainder);
            this.responseAfterMsgId = remainder;
        }

        protected override void InitPdu()
        {
            base.InitPdu();
            CommandStatus = 0;
            CommandID = CommandIdType.submit_sm_resp;
        }

        public override void ToMsbHexEncoding()
        {
            ArrayList pdu = GetPduHeader();
            pdu.AddRange(SmppStringUtil.ArrayCopyWithNull(Encoding.ASCII.GetBytes(MessageId)));

            PacketBytes = EncodePduForTrasmission(pdu);
        }
    }
}
