using System;

namespace SMPP.Utility
{
	/// <summary>
	/// Utility class to do big-endian to little endian conversions and the like.
	/// This is for unsigned numbers only; use the IPAddress class for signed values.
	/// </summary>
	public sealed class UnsignedNumConverter
	{
		
		private UnsignedNumConverter()
		{
		}
		
		
		public static UInt32 SwapByteOrdering(UInt32 val)
		{
			if(val < 0)
				return 0;
			return((val << 24)& 0xFF000000)+((val << 8)& 0x00FF0000)+
					((val >> 8)& 0x0000FF00)+((val >> 24)& 0x000000FF);
		}
		
		
		public static UInt16 SwapByteOrdering(UInt16 val)
		{
			if(val < 0)
			{
				return 0;
			}
			
			UInt16 newVal = (UInt16)(((val << 8)& 0xFF00)+((val >> 8)& 0x00FF));
			
			return newVal;
		}
	}
}
