using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Xml;
using System.Xml.Serialization;

namespace SMSPlatform
{
    [Serializable]
    public class Configuration
    {
        #region Fields

        private string connectionString;
        private int number;
        private string smpp_host_address;
        private short smpp_port;
        private string smpp_system_id;
        private string smpp_system_password;
        private int enquirelinkinterval;
        private string failSMS;
        private string logPath;

        #endregion

        #region Properties

        public string ConnectionString
        {
            get
            {
                return this.connectionString;
            }
            set
            {
                this.connectionString = value;
            }
        }
        
        public int Number
        {
            get
            {
                return this.number; 
            }
            set
            {
                this.number = value;
            }
        }

        public string SMPP_Host_Address
        {
            get
            {
                return this.smpp_host_address;
            }
            set
            {
                this.smpp_host_address = value;
            }
        }

        public short SMPP_Port
        {
            get
            {
                return this.smpp_port;

            }
            set
            {
                this.smpp_port = value;
            }
        }

        public string SMPP_System_ID
        {
            get
            {
                return this.smpp_system_id;
            }
            set
            {
                this.smpp_system_id = value;
            }
        }

        public string SMPP_System_Password
        {
            get
            {
                return this.smpp_system_password;
            }
            set
            {
                this.smpp_system_password = value;
            }
        }
        public int EnquireLinkInterval
        {
            get
            {
                return this.enquirelinkinterval;
            }
            set
            {
                this.enquirelinkinterval = value;
            }
        }
        public string FailSMS
        {
            get
            {
                return this.failSMS;
            }
            set
            {
                this.failSMS = value;
            }
        }
        public string LogPath
        {
            get
            {
                return this.logPath;
            }
            set
            {
                this.logPath = value;
            }
        }

            
                
            
              
        
        #endregion

        #region Constructor

        public Configuration()
        {
            this.Number = 90440;
            this.SMPP_Host_Address = "10.96.211.50";
            this.SMPP_Port = 3701;
            this.SMPP_System_ID = "SMPP1";
            this.SMPP_System_Password = "smsc1";
            this.EnquireLinkInterval = 10;
        }

        #endregion

        #region Methods

        public static void Serialize(string file, Configuration c)
        {
            System.Xml.Serialization.XmlSerializer xs
                = new System.Xml.Serialization.XmlSerializer(c.GetType());
            StreamWriter writer = File.CreateText(file);
            xs.Serialize(writer, c);
            writer.Flush();
            writer.Close();
        }

        public static Configuration Deserialize(string file)
        {
            System.Xml.Serialization.XmlSerializer xs
                = new System.Xml.Serialization.XmlSerializer(
                typeof(Configuration));
            StreamReader reader = File.OpenText(file);
            Configuration c = (Configuration)xs.Deserialize(reader);
            reader.Close();
            return c;
        }

        #endregion

    }
}
